<template>
  <div class="row items-start">
    <div class="col-12">
      <q-select v-model="productType" label="Pilih Tipe Produk" :options="selectProductType"
                standout="bg-green text-white" @input="pilihKategori"
                hint="Jenis Produk Menentukan dimana produk anda akan ditampilkan dan diklarifikasi." />
    </div>
    <div class="col-12" style="margin-top: 15px">
      <q-select v-model="kategori" label="Pilih Kategori" :options="optionKategori" standout="bg-green text-white"
                hint="Pilih salah satu kategori yang anda masukan ketika membuat provider." />
    </div>
    <q-separator style="margin-top: 20px" />
    <div class="col-12" v-if="productType.is_jasa == null">
      <label>Belum Pilih Produk Tipe</label>
    </div>
    <div class="col-12" v-if="productType.is_jasa == 1">
      <form-product-jasa @submit="submit" :formTambahan="formTambahan" />
    </div>

    <div class="col-12" v-if="productType.is_jasa == 0">
      <form-product-lowongan @submit="submit" :formTambahan="formTambahan" />
    </div>

    <q-separator style="margin-top: 20px" />

  </div>
</template>

<script>

import FormProductJasa from "components/Product/FormProductJasa";
import FormProductLowongan from "components/Product/FormProductLowongan";

export default {
  name: 'CreateProductStep2',

  components: {
    FormProductLowongan, FormProductJasa
  },

  data () {
    return {
      kategori: {
        label: null,
        value: null
      },
      productType: {
        label: null,
        value: null,
        form: null,
        is_jasa: null
      },
      optionKategori : null,
      form: {},
      formTambahan: []
    }
  },

  methods: {
    pilihKategori(val) {
      this.optionKategori = this.selectKategori.filter(data => {
        this.formTambahan = JSON.parse(this.productType.form);
        return data.product_type == this.productType.value;
      })
      this.kategori = {
        label: null,
        value: null
      }
    },
    async submit(val) {
      this.form = await val;

      let data = new FormData();
      data.append('id_product_type', this.productType.value);
      data.append('id_category', this.kategori.value);
      data.append('name_product', this.form.name_product);
      data.append('desc_product', this.form.desc_product);
      data.append('price', this.form.price);
      data.append('starting_price', this.form.starting_price);
      data.append('final_price', this.form.final_price);
      data.append('custom_form', JSON.stringify(this.form.form));
      if (this.form.price_prone_flag) {
        data.append('price_prone_flag', 1);
      } else {
        data.append('price_prone_flag', 0);
      }

      data.append('id_unit_price', this.form.id_unit_price.value);
      data.append('level', '0');

      await this.$axios.post("api/product/information/create", data)
        .then(response => {
          if (this.productType.is_jasa == 1) {
            this.$emit("submit", 3, response);
          } else {
            this.$emit("submit", 4, response);
          }

        })
        .catch(error => {
          this.$q.notify({
            message: "Periksa Kembali Form Anda"
          })
        })

    }
  },

  computed: {
    selectKategori() {
      return this.$store.state.kategori.selectKategori;
    },

    selectProductType() {
      return this.$store.state.ProductType.selectProductType;
    }
  }
}
</script>
